<id>
Recent posts user preference
</id>

<version>
1.0
</version>

<mod info>
Per user customization of recent forum posts
</mod info>

<author>
miseryshining
</author>

<homepage>
http://simplemachines.org
</homepage>

<edit file>
/Themes/default/languages/Profile.english.php
</edit file>
<search for>
$txt['no_buddies'] = 'Your buddy list is currently empty';
</search for>
<add after>

$txt['RP_title'] = 'Recent posts settings';
$txt['RP_info'] = 'Here you can setup preferences for the recent post box.';
$txt['RP_lastOnly'] = 'Only show the last reply of a thread';
$txt['RP_nrofPosts'] = 'Number of posts to show';
$txt['RP_recentPosts'] = $txt['recentPosts'] = 'Recent posts preferences';
$txt['RP_listheader'] = 'check the boards you want to monitor';
</add after>

<edit file>
/Sources/Load.php
</edit file>

<search for>
	// Set up the $user_info array.
	$user_info += array(
</search for>
<add after>
		'recentPosts' => array('boards' => (!empty($user_settings['recentpostBoards']) ? explode(',',$user_settings['recentpostBoards']) : array()), 'lastOnly' => (!empty($user_settings['recentLastOnly']) ? 1 : "NULL"), 'nrofPosts' => (!empty($user_settings['recentNrofPosts']) ? $user_settings['recentNrofPosts']  : "10")),
</add after>

<search for>
	// Set up the contextual user array.
	$context['user'] = array(
</search for>
<add after>
		'recentPosts' => &$user_info['recentPosts'],
</add after>

<edit file>
/SSI.php
</edit file>

<search for>
// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<add before>
// Recent posts & topics user preference: 	[board] Subject by Poster	Date 
function ssi_recentPostsPref()
{
	global $context;
	if ($context['user']['recentPosts']['lastOnly'] == 1)
		ssi_recentTopics($context['user']['recentPosts']['nrofPosts'], null, 'echo', $context['user']['recentPosts']['boards']);
	else 
		ssi_recentPosts($context['user']['recentPosts']['nrofPosts'], null, 'echo', $context['user']['recentPosts']['boards']);
}

</add before>
<replace>
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null)
</replace>

<search for>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<replace>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null)
</replace>

<search for>
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
</search for>
<replace>
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.ID_BOARD IN (" . implode(', ', $include_boards) . ")"  : '')."
</replace>

<edit file>
/Sources/Profile.php
</edit file>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</add after>

<search for>
			$context['profile_areas']['edit_profile']['areas']['theme'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=theme">' . $txt['theme'] . '</a>';
</search for>
<add after>
			$context['profile_areas']['edit_profile']['areas']['recentPosts'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=recentPosts">' . $txt['RP_recentPosts'] . '</a>';
</add after>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</add after>

<search for>
		makeThemeChanges($memID, isset($_POST['ID_THEME']) ? (int) $_POST['ID_THEME'] : $old_profile['ID_THEME']);
</search for>
<add after>
		makeRecentPostsChanges($memID);
</add after>

<search for>
// Make any notification changes that need to be made.
function makeNotificationChanges($memID)
</search for>
<add before>
// Make any recent board changes that are sent with the profile..
function makeRecentPostsChanges($memID)
{
	global $db_prefix, $modSettings;
	$boardRecentStr = implode(',', $_POST['boardRecent']);
	if (!$boardRecentStr) $boardRecentStr = 0;
	if (isset($_POST['lastOnly']))
		$recentLastOnly = 1; 
	else $recentLastOnly = 0;
	if (empty($_POST['nrofPosts'])) $_POST['nrofPosts'] = 10;
	
	db_query("
		UPDATE {$db_prefix}members 
		SET recentpostBoards = '{$boardRecentStr}',
		recentLastOnly = $recentLastOnly,
		recentNrofPosts = {$_POST['nrofPosts']}
		WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
}

</add before>

<search for>
// Display the notifications and settings for changes.
function notification($memID)
</search for>
<add before>
function recentPosts($memID)
{
	global $txt, $context, $user_profile, $db_prefix, $modSettings, $settings, $user_info, $ID_MEMBER;

	//select user preference if $memID != user ID. 
	if ($ID_MEMBER != $memID) {
		$result = db_query("SELECT recentpostBoards, recentLastOnly, recentNrofPosts FROM {$db_prefix}members WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
		$row = mysql_fetch_assoc($result);
		$context['user']['recentPosts']['boards'] = !empty($row['recentpostBoards']) ? explode(',',$row['recentpostBoards']) : array();
		$context['user']['recentPosts']['lastOnly'] = !empty($row['recentLastOnly']) ? 1 : "NULL";
		$context['user']['recentPosts']['nrofPosts'] = !empty($row['recentNrofPosts']) ? $row['recentNrofPosts'] : "10";
	}
	

	$recentpostBoards = $context['user']['recentPosts']['boards'];

	$result = db_query("
		SELECT ID_GROUP, groupName
		FROM {$db_prefix}membergroups
		WHERE (ID_GROUP > 3 OR ID_GROUP = 2)" . (empty($modSettings['permission_enable_postgroups']) ? "
			AND minPosts = -1" : '') . "
		ORDER BY minPosts, ID_GROUP != 2, groupName", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['groups'][] = array(
			'id' => $row['ID_GROUP'],
			'name' => $row['groupName']
		);
	mysql_free_result($result);
		
	$result_boards = db_query("
		SELECT
			b.ID_BOARD, b.name AS boardName, b.childlevel, b.description,
			b.numPosts, b.numTopics, b.ID_PARENT
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (empty($modSettings['countChildPosts']) ? "
			AND b.childLevel <= 1" : ''), __FILE__, __LINE__);

		$context['boards'] = array();
		while ($row = mysql_fetch_assoc($result_boards))
		$context['boards'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['boardName'],
			'child_level' => $row['childlevel'],
			'selected' => false,
			'monitor' => (in_array($row['ID_BOARD'],$recentpostBoards)) ? 1 : -1
		);
		mysql_free_result($result_boards);
	
	loadThemeOptions($memID);

	loadLanguage('Settings');
}

</add before>


<edit file>
/Themes/default/Profile.template.php
</edit file>

<search for>
function template_notification()
</search for>
<add before>
// Template for showing recent posts settings.
function template_recentPosts()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt, $user_info;
	
	if (!empty($context['boards']))
	{
		echo '
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" border="0" align="top" />&nbsp;
						' . $txt['RP_title'] . '
					</td>
				</tr><tr class="windowbg">
					<td class="smalltext" height="25" style="padding: 2ex;">
						' . $txt['RP_info'] . '
					</td>
				</tr><tr>
				<td class="windowbg2" style="padding-bottom: 2ex;">
				<form action="', $scripturl, '?action=profile2" method="post" accept-charset="', $context['character_set'], '" style="margin: 0;">
				<table border="0" width="100%" cellpadding="3">
				  	<tr class="windowbg2">
					<td valign="top">
						<fieldset>
						<legend>',$txt['RP_listheader'],'</legend>';
						foreach ($context['boards'] as $board) {
							echo '<div style="margin-left: ', $board['child_level'], 'em;"><input type="checkbox" name="boardRecent[]" id="boardaccess_', $board['id'], '" value="', $board['id'], '" ', $board['monitor'] == 1 ? ' checked="checked"' : '', ' class="check" /> <label for="boardaccess_', $board['id'], '">', $board['name'], '</label></div>';
						}

		echo '<br />
							<input type="checkbox" id="checkall_check" class="check" onclick="invertAll(this, this.form, \'boardRecent\');" /> <label for="checkall_check"><i>', $txt[737], '</i></label>
						</fieldset>
					</td>
				</tr>
				<tr class="windowbg2">
				<td valign="top"><input type="checkbox" class="check" name="lastOnly" id="lastOnly" ', $context['user']['recentPosts']['lastOnly'] == 1 ? 'checked="checked"': '',' /><label for="lastOnly">' . $txt['RP_lastOnly'] . '</label></td>
				</tr>
				<tr class="windowbg2">
				<td valign="top"><label for="nrofPosts">' . $txt['RP_nrofPosts'] . '</label>&nbsp;
				<select name="nrofPosts" />
				<option ',($context['user']['recentPosts']['nrofPosts'] == 5 ? 'SELECTED' : ''),'>5</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 10 || !isset($context['user']['recentPosts']['nrofPosts']) ? 'SELECTED' : ''),'>10</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 15 ? 'SELECTED' : ''),'>15</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 20 ? 'SELECTED' : ''),'>20</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 25 ? 'SELECTED' : ''),'>25</option>
				</select>
				</td>
				</tr>
				<tr class="windowbg2">
				<td valign="top">', 				
				template_profile_save(),'
				</td>
				</tr></table>
				</form>
				</td>
			</tr></table>
				';
	}
}

</add before>
